#!/usr/local/bin/perl

######################################################################
# MajorForm 1.0 - A tool to easily subscribe unsubscribe users to or #
#              from a MajorDomo mailing list via a form.             #
#--------------------------------------------------------------------#
#     This script is open source, and can be used as you please.     #
#  All that I ask is that you drop me a line at: <caleb@inetwiz.com> #
######################################################################

# Define Variables
$mailprog = '/usr/lib/sendmail -oi -t';           # Path to sendmail
$host = 'you.domain';                             # The part after majordomo@
$listname = 'list';                               # The name of the list
$done = 'http://www.your.domain/thank-you.html';  # Where to go if all goes well
$badmail = 'http://www.your.domain/error.html';   # Where to go if e-mail adddress is bad

#######

read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});     # Get the input
@pairs = split(/&/, $buffer);                     # Split the name-value pairs (parsing)

#######

# More Parsing
foreach $pair (@pairs){
   ($name, $value) = split(/=/, $pair);

   $value =~ tr/+/ /;
   $value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $name =~ tr/+/ /;
   $name =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   $FORM{$name} = $value;
}

#######

# Validate the e-mail address
if ($FORM{'address'} eq "you\@your.isp") {
   print "Location: $badmail\n\n";
   exit;
} else {
    $testmail = $FORM{'address'};
    if ($testmail =~ /(@.*@)|(\.\.)|(@\.)|(\.@)|(^\.)/ ||
      $testmail !~ /^.+\@(\[?)[a-zA-Z0-9\-\.]+\.([a-zA-Z]{2,3}|[0-9]{1,3})(\]?)$/)
      {
      print "Location: $badmail\n\n";
      exit;
      } else {
      print "Location: $done\n\n";   
      }

}

#######

# Open The Mail
open(MAIL, "|$mailprog") || die "Can't open $mailprog!\n";
print MAIL "To: majordomo\@$host\n";
print MAIL "From: $FORM{'address'}\n";
print MAIL "Subject: Subscribe/Unsubscribe $listname\n";

#######

# Tell majordomo what to do
if ($FORM{'action'} eq "unsubscribe") {
   print MAIL "unsubscribe $listname $FORM{'address'}";
} else {
   print MAIL "subscribe $listname $FORM{'address'}";
}

#######

print MAIL "\n";                                  # Feed mail a blank line
close (MAIL);                                     # Close mail cleanly
